(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */

})( jQuery );

jQuery(document).ready(function($){

	//Display schedule section from here
	jQuery("#schedule_type").change(function(){
		if(jQuery(this).val() !== ''){
			jQuery(".schedule_detail_sec_raw").css('display','table-row');
			var labelText = jQuery("#schedule_type option:selected").text().toLowerCase();
			if(labelText == 'daily'){
				labelText = 'This event will repeat every day';
			}
			else if(labelText == 'weekly'){
				labelText = 'This event will repeat every week';
			}
			else if(labelText == 'monthly'){
				labelText = 'This event will repeat every Month';
			}
			else{
				labelText = 'This event will repeat every Year';
			}
		//	jQuery("#display_schedule_type").html(labelText);
			if(jQuery(this).val() == 'weekly'){
				jQuery(".weekly").css('display','table-row');
			}
			else{
				jQuery(".weekly").css('display','none');
			}

			if(jQuery(this).val() == 'monthly'){
				jQuery(".monthly").css('display','table-row');
			}
			else{
				jQuery(".monthly").css('display','none');
			}
		}
		else{
			jQuery(".schedule_detail_sec_raw").css('display','none');
		}
	});

	 //Time picker
	jQuery('.schedule-time').datetimepicker({
	  format:'H:i',
	  timepicker:true,
	  datepicker:false,
	  closeOnDateSelect:true,
	  //minDate:0,
	  //minTime:0,
	  step:30,
	  scrollMonth: false,
	 });

	 //Date picker
	jQuery('.schedule-end-date').datetimepicker({
	  format:'d/m/Y',
	  timepicker:false,
	  datepicker:true,
	  closeOnDateSelect:true,
	  minDate:0,
	  //minTime:0,
	  //step:30,
	  scrollMonth: false,
	 });

	 jQuery('.schedule-time, .schedule-end-date').attr('readonly','true');
	 jQuery('.schedule-time, .schedule-end-date').css('background-color','#fff');

	 //Allow only integer and float value
	jQuery('input.number-only').on('input', function() {
	  this.value = this.value.replace(/[^0-9]/g, '');
	});

	//Define search date filter validation here
	jQuery("#schedule_from_date").datetimepicker({
		format:"d/m/Y",
		timepicker:false,
		closeOnDateSelect:true,
		onSelectDate:function(ct,$i){
			 var selecteddate = ct.dateFormat("d/m/Y");
			 var enddate = jQuery("#schedule_to_date").val();

			if(enddate){
				dateFirst = selecteddate.split("/");
				dateSecond = enddate.split("/");
				var value = new Date(dateFirst[2], dateFirst[1]-1, dateFirst[0]); //Year, Month, Date
				var current = new Date(dateSecond[2], dateSecond[1]-1, dateSecond[0]);
				var d1 = new Date(value);
				var d2 = new Date(current);
				if(d1 > d2){
					toDate = new Date(new Date(d1).getTime() + 24 * 60 * 60 * 1000).dateFormat("d/m/Y");
					jQuery("#schedule_to_date").val(toDate);
					//jQuery("#schedule_to_date").focus();
				}
			}
		},
		//minDate:"-1969/12/31",
		 scrollMonth: false,
	});

	//check to date field validation here
	jQuery("#schedule_to_date").datetimepicker({
		format:"d/m/Y",
		timepicker:false,
		closeOnDateSelect:true,
		onShow:function( ct ){
			var fromDate = jQuery("#schedule_from_date").val();
			if(fromDate != ""){
				var fromDateArr = fromDate.split("/");
				fromDateArr.reverse();
				fromDate = fromDateArr.join("/");
				fromDate = new Date( new Date(fromDate).getTime());
			}
			else{
				var fromDate = new Date(  );
			}
			this.setOptions({
				minDate: jQuery("#schedule_from_date").val() ? fromDate:false
			})
		},
		onSelectDate:function(ct,$i){
			 var selecteddate = ct.dateFormat("d/m/Y");
			 var enddate = jQuery("#schedule_from_date").val();
			if(enddate){
				dateFirst = selecteddate.split("/");
				dateSecond = enddate.split("/");

				var value = new Date(dateFirst[2], dateFirst[1], dateFirst[0]); //Year, Month, Date
				var current = new Date(dateSecond[2], dateSecond[1], dateSecond[0]);
				var d1 = new Date(value);

				var d2 = new Date(current);
				if(d1 < d2){
					jQuery("#schedule_from_date").val("");
					jQuery("#schedule_from_date").focus();
				}
			}
		},
		//minDate:0,
		scrollMonth: false,
	});

	//Add schedule fields validation here
	var page_type = $("#post_type").val();
	if(jQuery(".wrap .schedule_report_error").length < 1){
		jQuery(".wp-header-end").after('<div class="schedule_report_error"></div>');
	}
	if(jQuery(".wrap .schedule_report_error").length < 1){
		 jQuery(".page-title-action").parent().after('<div class="schedule_report_error"></div>');
	}
	if(page_type == 'schedule_report'){
		$("#publish").unbind().click(function(){
			jQuery('.vsz-error').remove();
			jQuery('.schedule_report_error').html('');
			var checkForm = true;
			var schedule_type = jQuery("#schedule_type").val();
			var schedule_option = jQuery("input[name$='vsz_acf7db_schedule_option']:checked").val();
			if(schedule_type != ''){

				//Check schedule repeat field empty or not
				if($("#schedule_repeat").val() == '' ){
					jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter Repeat Every</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					$("#schedule_repeat").css("border","1px solid red");
					checkForm = false;
				}
				else if(parseInt($("#schedule_repeat").val()) == 0 ){
					jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Repeat Every value should not be 0.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					$("#schedule_repeat").css("border","1px solid red");
					checkForm = false;
				}
				else{
					$("#schedule_repeat").css("border","");
				}

				//Check schedule time field empty or not
				if($("#schedule_time").val() == '' ){
					jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter Schedule Time.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					$("#schedule_time").css("border","1px solid red");
					checkForm = false;
				}
				else{
					$("#schedule_time").css("border","");
				}

				//Check schedule form field empty or not
			}
			//email metabox
			if(schedule_option == "export"){
				// From name
				if($("#schedule_form_id").val() == '' ){
					jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Either no forms submitted or you just forgot to select one form to export the records.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					$("#schedule_form_id").css("border","1px solid red");
					checkForm = false;
				}
				else{
					$("#schedule_form_id").css("border","");
				}
				
				if(jQuery("#schedule_email_active").attr("checked")){
					if($("#schedule_from_name").val() == ''){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter From name.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
						$("#schedule_from_name").css("border","1px solid red");
						checkForm = false;

					}else{
						$("#schedule_from_name").css("border","");
					}

					// From email
					var email = $("#schedule_from_email").val();
					if($("#schedule_from_email").val() == '' ){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter From email.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
						$("#schedule_from_email").css("border","1px solid red");
						checkForm = false;
					}else if (!validateCustomFormEmail(email)){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter valid From email.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
						$("#schedule_from_email").css("border","1px solid red");
						checkForm = false;
					}
					else{
						$("#schedule_from_email").css("border","");
					}

					// To email
					var toemail = $("#schedule_to").val();
					var checksplitemail = '';
					if($("#schedule_to").val() == '' ){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter To email.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
						$("#schedule_to").css("border","1px solid red");
						checkForm = false;
					}else if(toemail.indexOf(',') != -1){
						var checksplitemail = toemail.split(",");
						for (i = 0; i < checksplitemail.length; i++) {
							if(!validateCustomFormEmail(checksplitemail[i])){
								jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter valid To email.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
								$("#schedule_to").css("border","1px solid red");
								checkForm = false;
								break;
							}
						}
					}
					else if (!validateCustomFormEmail(toemail)){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter valid To email.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
						$("#schedule_to").css("border","1px solid red");
						checkForm = false;
					}
					else{
						$("#schedule_to").css("border","");
					}
					if($("#schedule_subject").val() == ''){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter email Subject.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
						$("#schedule_subject").css("border","1px solid red");
						checkForm = false;
					}else{
						$("#schedule_subject").css("border","");
					}
					if($("#schedule_message_body").val() == ''){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter email Message Body.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
						$("#schedule_message_body").css("border","1px solid red");
						checkForm = false;

					}else{
						$("#schedule_message_body").css("border","");
					}
				}
				
				//Contact form validation
				var check_rule = jQuery('.rule_data .rule-main').length;
				if(check_rule != 0){
					var chech_rule_error = 0;
					jQuery('.rule_data .rule-main').each(function(){
						var fields_value =  jQuery(this).find('.fields_value').val();
						if(fields_value == ''){
							chech_rule_error = 1;
							jQuery(this).find('.fields_value').css("border","1px solid red");
							checkForm = false;
						}else{
							jQuery(this).find('.fields_value').css("border","");
						}
					});
					if(chech_rule_error == 1){
						jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Enter rule value.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					}
				}
				if(checkForm){
					jQuery("#rule-main-fixed").remove();
					if(check_rule != 0){
						var index = 0;
						jQuery('.rule_data .rule-main').each(function(){
							jQuery(this).find('.fields_name').attr('name','schedule_contact_form_rule['+index+'][fields_name]');
							jQuery(this).find('.fields_condition').attr('name','schedule_contact_form_rule['+index+'][fields_condition]');
							jQuery(this).find('.fields_value').attr('name','schedule_contact_form_rule['+index+'][fields_value]');
							index++;
						});
					}
					return true;
				}
				else{
					return false;
				}
			}else if(schedule_option == "delete"){
				//Day selection
				if(jQuery("#delete_day").val() == ''){
					jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Please select day type for deleting the records.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					jQuery("#delete_day").css("border","1px solid red");
					checkForm = false;

				}else{
					jQuery("#delete_day").css("border","");
				}
				//Day number selection
				if(jQuery("#delete_day_number").val() == ''){
					jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Please enter number of days before to be set for deleting the records.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					jQuery("#delete_day_number").css("border","1px solid red");
					checkForm = false;

				}else{
					jQuery("#delete_day_number").css("border","");
				}
				//Form selection
				var count_checked = jQuery("[name='schedule_delete_form_id[]']:checked").length;
				if(count_checked == 0){
					jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p>Either no forms submitted or you just forgot to select one form to delete the records.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
					jQuery("[name='schedule_delete_form_id[]']").css("border","1px solid red");
					checkForm = false;

				}else{
					jQuery("[name='schedule_delete_form_id[]']").css("border","");
				}
				if(checkForm){

				}else{
					return false;
				}
			}
		});
	}

	// Starts by hiding the "Contact form/email/report history/delete" meta box
    jQuery( "#vsz_acf7db_contact_form_details" ).addClass( "hidden" );
    jQuery( "#vsz_acf7db_schedule_email_manager" ).addClass( "hidden" );
    jQuery( "#vsz_acf7db_schedule_delete" ).addClass( "hidden" );
    jQuery( "#vsz_acf7db_schedule_report_history" ).addClass( "hidden" );

    var tbody = jQuery("#acf7db_sr_report_table tbody");

    if( jQuery( "input#vsz_acf7db_schedule_option_export" ).is(':checked') ){
    	jQuery('.schedule-tooltip').tooltip({html:true});
	    jQuery( "#vsz_acf7db_contact_form_details" ).removeClass( "hidden" );
        jQuery( "#vsz_acf7db_schedule_email_manager" ).removeClass( "hidden" );
        jQuery( "#vsz_acf7db_schedule_report_history" ).removeClass( "hidden" );
        if (tbody.children().length == 0) {
		    jQuery( "#vsz_acf7db_schedule_report_history" ).addClass( "hidden" );
		}
    }
    if( jQuery( "input#vsz_acf7db_schedule_option_delete" ).is(':checked') ){
        jQuery( "#vsz_acf7db_schedule_delete" ).removeClass( "hidden" );
    }
	// If "Video" post format is selected, show the "Video Options" meta box
    jQuery( "input[name$='vsz_acf7db_schedule_option']" ).change( function() {
        var option = jQuery(this).val();
        if( option == "export" ){
			var isReport = jQuery("#acf7db_sr_report_table").attr("data-hide");
			if(isReport == "yes"){
				jQuery( "#vsz_acf7db_schedule_report_history" ).addClass( "hidden" );
			}
			else{
				jQuery( "#vsz_acf7db_schedule_report_history" ).removeClass( "hidden" );
			}
			
            jQuery( "#vsz_acf7db_contact_form_details" ).removeClass( "hidden" );
	        jQuery( "#vsz_acf7db_schedule_email_manager" ).removeClass( "hidden" );
	        jQuery( "#vsz_acf7db_schedule_delete" ).addClass( "hidden" );
	        jQuery('.schedule-tooltip').tooltip({html:true});

	        if (tbody.children().length == 0) {
			    jQuery( "#vsz_acf7db_schedule_report_history" ).addClass( "hidden" );
			}
        }
        if( option == "delete" ){
            jQuery( "#vsz_acf7db_contact_form_details" ).addClass( "hidden" );
	        jQuery( "#vsz_acf7db_schedule_email_manager" ).addClass( "hidden" );
	        jQuery( "#vsz_acf7db_schedule_report_history" ).addClass( "hidden" );
	        jQuery( "#vsz_acf7db_schedule_delete" ).removeClass("hidden" );
        }
    });


	jQuery(document).on('click','.notice-dismiss',function(){
					jQuery(this).parent().remove();
				});

});
function validateCustomFormEmail(email) {
			if(email == '[ADMIN_EMAIL]'){
				return true;
			}
			var expr = /^([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,10}|[0-9]{1,3})(\]?)$/;
			return expr.test(email);
		}
//change event
function messagevaluechange(){
	var schedule_type = jQuery("#schedule_type").val();
	var schedule_repeat = jQuery("#schedule_repeat").val();
	var schedule_week_day = jQuery("#schedule_week_day option:selected").text();
	var schedule_end_date = jQuery("#schedule_end_date").val();
	var labelText = jQuery("#schedule_type option:selected").text().toLowerCase();
	var untill = '';

	var weeekday = 'on '+schedule_week_day+' ';
	if(schedule_end_date != ''){
		untill =  'until '+ schedule_end_date;
	}
	if(labelText == 'daily'){
		if(schedule_repeat == 1){
			labelText = 'This event will repeat every day '+ untill;
		}else{
			labelText = 'This event will repeat every '+schedule_repeat+' day '+ untill;
		}
	}
	else if(labelText == 'weekly'){
		if(schedule_repeat == 1){
			labelText = 'This event will repeat every week '+ weeekday + untill;
		}else{
			labelText = 'This event will repeat every '+schedule_repeat+' week '+ weeekday + untill;
		}
	}
	else if(labelText == 'monthly'){
		if(schedule_repeat == 1){
			labelText = 'This event will repeat every month '+ untill;
		}else{
			labelText = 'This event will repeat every '+schedule_repeat+' month '+ untill;
		}
	}
	else{
		if(schedule_repeat == 1){
			labelText = 'This event will repeat every year '+ untill;
		}else{
			labelText = 'This event will repeat every '+schedule_repeat+' year '+ untill;
		}
	}
	jQuery("#display_schedule_type").html(labelText);

}




