<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://www.vsourz.com
 * @since      1.0.3
 *
 * @package    Acf7db_schedule_report
 * @subpackage Acf7db_schedule_report/admin/partials
 */
global $wpdb;
$arrMeta = get_post_meta($post->ID);
$schedule_form_id_delete = '';
//enqueue CSS and JS file here
$delete_day = isset($arrMeta['delete_day']) ? sanitize_text_field($arrMeta['delete_day'][0]) : '';
$delete_day_number = isset($arrMeta['delete_day_number']) ? sanitize_text_field($arrMeta['delete_day_number'][0]) : '';
$schedule_delete_form_id = isset($arrMeta['schedule_delete_form_id']) ? sanitize_text_field($arrMeta['schedule_delete_form_id'][0]) : '';
if(!empty($schedule_delete_form_id)){
	$schedule_delete_form_ids = explode(',', $schedule_delete_form_id);
}else{
	$schedule_delete_form_ids = '';
}

//Define filter for not create form schedule
$arr_not_schedule_forms = (array) apply_filters('vsz_acf7db_not_allowed_schedule_forms',array());
?>
<style type="text/css">
.acf7db-schedule-report .form-table tr input[type="text"] ,
.acf7db-schedule-report .form-table tr input[type="search"] ,
.acf7db-schedule-report .form-table tr input[type="tel"] ,
.acf7db-schedule-report .form-table tr input[type="time"] ,
.acf7db-schedule-report .form-table tr input[type="url"] ,
.acf7db-schedule-report .form-table tr input[type="week"] ,
.acf7db-schedule-report .form-table tr input[type="password"] ,
.acf7db-schedule-report .form-table tr input[type="color"] ,
.acf7db-schedule-report .form-table tr input[type="date"] ,
.acf7db-schedule-report .form-table tr input[type="datetime"] ,
.acf7db-schedule-report .form-table tr input[type="datetime-local"] ,
.acf7db-schedule-report .form-table tr input[type="email"] ,
.acf7db-schedule-report .form-table tr input[type="month"] ,
.acf7db-schedule-report .form-table tr input[type="number"] ,
.acf7db-schedule-report .form-table tr select ,
.acf7db-schedule-report .form-table tr textarea{
	width: 100%;
}
.acf7db-schedule-report .email-manager-outer span.mailtag{
	display: inline-block;
	margin: 0 0 0 4px;
	padding: 1px 2px;
	cursor: pointer;
	color: #000;
}
.acf7db-schedule-report .email-manager-outer legend{
	line-height: 1.5;
}
.acf7db-schedule-report .email-manager-outer .form-table tr textarea{
	height: 200px;
}
.mar10{
	margin:10px 0;
}
.clear-fix::after{
	content: '';
	clear: both;
	display: table;
}
.vsz-col-3{
	width: 30%;
    display: inline-block;
    vertical-align: middle;
    margin-right: 15px;
    float: left;
    margin-bottom: 10px;
}
.vsz-col-3:nth-child(3n+1){
	clear: both;
}
</style>
<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<table class="form-table">
	<tbody>
		<tr>
			<th>
				<label class="control-label col-sm-2" for="schedule_form_id"><?php _e('Delete Records before',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>*</label>
			</th>
			<td>
				<select name="delete_day" class="form-control" id="delete_day" style="width: 15%; display: inline-block; vertical-align: middle;">
					<option value=""><?php _e('Select',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
					<option value="day" <?php if($delete_day == "day"){ echo "selected";} ?>><?php _e('Day',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
					<option value="week" <?php if($delete_day == "week"){ echo "selected";} ?>><?php _e('Week',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
					<option value="month" <?php if($delete_day == "month"){ echo "selected";} ?>><?php _e('Month',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
				</select>
				<input type="number" class="form-control" min="1" name="delete_day_number" id="delete_day_number" value="<?php echo $delete_day_number; ?>" style="width: 15%; display: inline-block; vertical-align: middle;">
			</td>
		</tr>
		<tr>
			<th>
				<label class="control-label col-sm-2" for="schedule_form_id"><?php _e('Delete For',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>*</label>
			</th>

				<?php
				//Check Advance Contact Form DB activate or not and contact form 7 version is greater than 4.6 version or not
				if(defined('VSZ_ACF7DB_ACTIVE') && VSZ_ACF7DB_ACTIVE && defined('WPCF7_VERSION') && WPCF7_VERSION > '4.6'){
					global $wpdb;
					//Get all existing contact form list
					$delete_form_list = vsz_cf7_get_the_form_list();
					//Get all form names which entry store in DB
					$sql_delete = sprintf("SELECT `cf7_id` FROM `".VSZ_CF7_DATA_ENTRY_TABLE_NAME."` GROUP BY `cf7_id`" );
					$data_delete = $wpdb->get_results($sql_delete,ARRAY_N);
					$arr_form_id_delete = array();
					if(!empty($data_delete)){
						foreach($data_delete as $arrVal){
							$arr_form_id_delete[] = (int)$arrVal[0];
						}
					}

					?><td>
						<div class="clear-fix"><?php
						//Display all existing form list here
							$display_check = false;
							if(!empty($delete_form_list)){
								foreach($delete_form_list as $objForm){
									if(!empty($arr_form_id_delete) && in_array($objForm->id(),$arr_form_id_delete) && !in_array($objForm->id(),$arr_not_schedule_forms)){
									$display_check = true;
									?><div class="vsz-col-3" style="">
										<label class="vsz-delete-checkbox">	<input type="checkbox" class="form-control" name="schedule_delete_form_id[]" <?php
											print 'value="'.$objForm->id().'"';
											if(!empty($schedule_delete_form_ids) && in_array($objForm->id(),$schedule_delete_form_ids)){
												print 'checked';
											}
											?>> <?php 
											echo esc_html($objForm->title()); 
										?></label>
									</div>
								<?php
									}//Close if
								}//close for each
								
								if(!$display_check){
									?><div><?php _e('No forms submitted.',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></div><?php
								}
								
							}//close if
							else{
								?><div><?php _e('No forms submitted.',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></div><?php
							}
						?></div>
					</td><?php
				}
				//Display error message
				elseif(defined('WPCF7_VERSION') && WPCF7_VERSION > '4.6') {
						?><td>
							<p class="description"><?php _e('Please update to latest version for Contact Form plugin first.',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>
						</td><?php
				}else{

					?><td>
						<p class="description"><?php 
							_e('Please activate Advance Contact Form DB plugin or update to latest version for Contact Form plugin first.',VSZ_ACF7DB_SR_TEXT_DOMAIN); 
						?></p>
					</td><?php
				}
			?>
		</tr>
		<tr>
			<td colspan="2">
				<div class="clear-fix">
					<div class="acf7_schedule_notice_outer">
						<p class="note"><?php _e('Example',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>
						<ul class="acf7_schedule_notice">	
							<li>
								<i class="fa fa-hand-o-right"></i>
								<?php _e('If you select schedule detail as below',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>:<br>
								<p><strong><?php _e('Schedule type',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>:</strong><?php _e('Daily',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>
								<p><strong><?php _e('Repeat Every',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>:</strong>2</p>
								<p><strong><?php _e('Schedule Time',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>:</strong>12:00</p>
								<p><strong><?php _e('Schedule End Date',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>:</strong>31/12/2018</p>
								<p><strong><?php _e('Delete Records Before',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>:</strong><?php _e('1 Month',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>
							</li>
							<li>
								<i class="fa fa-hand-o-right"></i><?php 
									_e('It means that delete process will executed every second day 12:00 up to 31/12/2018 and every second day, all selected form\'s data will deleted before 1 month from schedule date and time.',VSZ_ACF7DB_SR_TEXT_DOMAIN); 
							?></li>
						</ul>
					</div>
				</div>
			</td>
		</tr>
	</tbody>
</table>
<script type="text/javascript">
	jQuery(document).ready(function($) {
		var numInput = document.querySelector('#delete_day_number');

		// Listen for input event on numInput.
		numInput.addEventListener('input', function(){
		    // Let's match only digits.
		    var num = this.value.match(/^\d+$/);
		    if (num === null) {
		        // If we have no match, value will be empty.
		        this.value = "";
		    }
		}, false);
	});
</script>
