<style type="text/css">
.acf7db-schedule-report .form-table tr input[type="text"] ,.acf7db-schedule-report .form-table tr input[type="search"] ,.acf7db-schedule-report .form-table tr input[type="tel"] ,.acf7db-schedule-report .form-table tr input[type="time"] ,.acf7db-schedule-report .form-table tr input[type="url"] ,.acf7db-schedule-report .form-table tr input[type="week"] ,.acf7db-schedule-report .form-table tr input[type="password"] ,.acf7db-schedule-report .form-table tr input[type="color"] ,.acf7db-schedule-report .form-table tr input[type="date"] ,.acf7db-schedule-report .form-table tr input[type="datetime"] ,.acf7db-schedule-report .form-table tr input[type="datetime-local"] ,.acf7db-schedule-report .form-table tr input[type="email"] ,.acf7db-schedule-report .form-table tr input[type="month"] ,.acf7db-schedule-report .form-table tr input[type="number"] ,.acf7db-schedule-report .form-table tr select ,.acf7db-schedule-report .form-table tr textarea{
	width: 100%;
}
.acf7db-schedule-report .email-manager-outer span.mailtag{
	display: inline-block;
	margin: 0 0 0 4px;
	padding: 1px 2px;
	cursor: pointer;
	color: #000;
}
.acf7db-schedule-report .email-manager-outer legend{
	line-height: 1.5;
}
.acf7db-schedule-report .email-manager-outer .form-table tr textarea{
	height: 200px;
}
.mar10{
	margin:10px 0;
}
</style>
<?php

//Get post related all meta information
$arrMeta = get_post_meta($post->ID);

$schedule_type = isset($arrMeta['schedule_type']) ? sanitize_text_field($arrMeta['schedule_type'][0]) : 'daily';
$schedule_repeat = isset($arrMeta['schedule_repeat']) ? absint($arrMeta['schedule_repeat'][0]) : 1;
$schedule_week_day = isset($arrMeta['schedule_week_day']) ? sanitize_text_field($arrMeta['schedule_week_day'][0]) : '';
$schedule_time = isset($arrMeta['schedule_time']) ? sanitize_text_field($arrMeta['schedule_time'][0]) : '';
$schedule_end_date = isset($arrMeta['schedule_end_date']) ? sanitize_text_field($arrMeta['schedule_end_date'][0]) : '';
if($schedule_repeat == 0){
	$schedule_repeat = 1 ;
}
$schedule_form_id = isset($arrMeta['schedule_form_id']) ? absint($arrMeta['schedule_form_id'][0]) : '';

//Display date in valid format
//check end date exist or not
$s_end_date = '';
if(!empty($schedule_end_date)){
	$s_end_date = date_create_from_format("Y-m-d",$schedule_end_date);
	if(!empty($s_end_date)){
		//Get end date information
		$s_end_date =  date_format($s_end_date,"d/m/Y");
	}
}

//check from date exist or not
$s_from_date = '';
if(!empty($schedule_from_date)){
	$s_from_date = date_create_from_format("Y-m-d",$schedule_from_date);
	if(!empty($s_from_date)){
		//Get from date information
		$s_from_date =  date_format($s_from_date,"d/m/Y");
	}
}

//check from date exist or not
$s_to_date = '';
if(!empty($schedule_to_date)){
	$s_to_date = date_create_from_format("Y-m-d",$schedule_to_date);
	if(!empty($s_to_date)){
		//Get to date information
		$s_to_date =  date_format($s_to_date,"d/m/Y");
	}
}

$schedule_option = isset($arrMeta['schedule_option']) ? sanitize_text_field($arrMeta['schedule_option'][0]) : '';
if($schedule_option == ''){
	$schedule_option = "export";
}

//enqueue CSS and JS file here
wp_enqueue_style("vsz_acf7db_bootstrap_min_css");
wp_enqueue_style("vsz_acf7db_schedule_datetime_css");
wp_enqueue_script("vsz_acf7db_schedule_datetime_js");
wp_enqueue_style("acf7db_schedule_select");
wp_enqueue_script("vsz_acf7db_multi-select.js");
wp_enqueue_script("vsz_acf7db_bootstrap_min_js");
wp_enqueue_script("vsz_acf7db_schedule_report_js");
//Define week days arra here
$arr_days = array(1 => __("Monday",VSZ_ACF7DB_SR_TEXT_DOMAIN), 2 => __("Tuesday",VSZ_ACF7DB_SR_TEXT_DOMAIN), 3 => __("Wednesday",VSZ_ACF7DB_SR_TEXT_DOMAIN), 4 => __("Thursday",VSZ_ACF7DB_SR_TEXT_DOMAIN), 5 => __("Friday",VSZ_ACF7DB_SR_TEXT_DOMAIN), 6 => __("Saturday",VSZ_ACF7DB_SR_TEXT_DOMAIN), 7 => __("Sunday",VSZ_ACF7DB_SR_TEXT_DOMAIN));
//Add filter for customize week days
$arr_week = (array) apply_filters('vsz_acf7db_change_week_days',$arr_days);

//Define filter for not create form schedule
$arr_not_schedule_forms = (array) apply_filters('vsz_acf7db_not_allowed_schedule_forms',array());


//Define global db variable
global $wpdb;


//Create nonce for checking in save time
$nonce = wp_create_nonce( 'vsz-acf7db-schedule-nonce-'.$post->ID );

?><table class="form-table">
	<tbody>
		<tr>
			<th>
				<label class="control-label col-sm-2" for="schedule_type"><?php _e('Schedule Type',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></label>
			</th>
			<td>
				<select class="form-control" id="schedule_type" name="schedule_type" onchange="messagevaluechange();">
					<option value="daily" <?php print $schedule_type == 'daily' ? 'selected' : '';?>><?php _e('Daily',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
					<option value="weekly" <?php print $schedule_type == 'weekly' ? 'selected' : '';?>><?php _e('Weekly',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
					<option value="monthly" <?php print $schedule_type == 'monthly' ? 'selected' : '';?>><?php _e('Monthly',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
					<option value="yearly" <?php print $schedule_type == 'yearly' ? 'selected' : '';?>><?php _e('Yearly',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></option>
				</select>
			</td>
		</tr>
		<tr class="schedule_detail_sec_raw"  style="display:<?php print !empty($schedule_type) ? 'table-row' : 'none';?>">
			<th>
				<label class="control-label col-sm-2" for="schedule_repeat"><?php _e('Repeat Every',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>*</label>
			</th>
			<td>
			  <input type="text" class="form-control schedule-repeat number-only" id="schedule_repeat" name="schedule_repeat" placeholder="<?php _e('Repeat Every',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>" value="<?php print $schedule_repeat;?>" onchange="messagevaluechange();">
			</td>
		</tr><?php
		//Display week days information
		if(!empty($arr_week) && !empty($schedule_type)){
			?><tr <?php if($schedule_type != 'weekly'){?>style="display:none" <?php } ?> class="weekly schedule_detail_sec_raw">
				<th>
					<label class="control-label col-sm-2" for="schedule_week_day"><?php _e('Week day',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></label>
				</th>
				<td>
					<select class="form-control" id="schedule_week_day" name="schedule_week_day" onchange="messagevaluechange();"><?php
						foreach($arr_week as $key => $day){
							$selected = '';
							if(!empty($schedule_week_day) && $schedule_week_day == $key)
								$selected = 'selected';
							print '<option value="'.$key.'" '.$selected.'>'.esc_html($day).'</option>';
						}
					?></select>
				</td>
			 </tr><?php
		}
		?><tr class="schedule_detail_sec_raw"  style="display:<?php print !empty($schedule_type) ? 'table-row' : 'none';?>">
			<th>
				<label class="control-label col-sm-2" for="schedule_time"><?php _e('Schedule Time',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>*</label>
			</th>
			<td>
			  <input type="text" class="form-control schedule-time" id="schedule_time" name="schedule_time" value="<?php print $schedule_time;?>" placeholder="<?php _e('Schedule Time',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>">
			</td>
		</tr>
		<tr class="schedule_detail_sec_raw"  style="display:<?php print !empty($schedule_type) ? 'table-row' : 'none';?>">
			<th>
				<label class="control-label col-sm-2" for="schedule_end_date"><?php _e('Schedule End Date',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></label>
			</th>
			<td>
			  <input type="text" class="form-control schedule-end-date" id="schedule_end_date" name="schedule_end_date" value="<?php print $s_end_date;?>" placeholder="<?php _e('Schedule End Date',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>" onchange="messagevaluechange();">
				 <p id="display_schedule_type" class="description"></p>
			</td>
		</tr>
		<tr>
			<th>
				<label class="control-label col-sm-2" for="schedule_file_type"><?php _e('Option',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></label>
			</th>
			<td>
				<input type="radio" name="vsz_acf7db_schedule_option" id="vsz_acf7db_schedule_option_export" value="export" <?php if($schedule_option == "export"){ echo "checked";} ?>><?php _e('Export',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>
				<input type="radio" name="vsz_acf7db_schedule_option" id="vsz_acf7db_schedule_option_delete" value="delete" <?php if($schedule_option == "delete"){ echo "checked";} ?>><?php _e('Delete',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>
			</td>
		</tr>
	 	<input type="hidden" name="vsz_acf7db_schedule_nonce"  value="<?php echo $nonce; ?>" />
	</tbody>
</table>
<script>
jQuery(document).ready(function(){
jQuery(window).load(function(){
if(jQuery("#vsz_acf7db_schedule_details-hide").prop("checked") == false){
	jQuery("#vsz_acf7db_schedule_details-hide").click();
}
if(jQuery("#vsz_acf7db_contact_form_details-hide").prop("checked") == false){
	jQuery("#vsz_acf7db_contact_form_details-hide").click();
}
if(jQuery("#vsz_acf7db_schedule_email_manager-hide").prop("checked") == false){
	jQuery("#vsz_acf7db_schedule_email_manager-hide").click();
}
if(jQuery("#vsz_acf7db_schedule_report_history-hide").prop("checked") == false){
	jQuery("#vsz_acf7db_schedule_report_history-hide").click();
}
if(jQuery("#vsz_acf7db_schedule_delete-hide").prop("checked") == false){
	jQuery("#vsz_acf7db_schedule_delete-hide").click();
}
});
});
</script>
