<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ){
	die('Un-authorized access!');
}
global $post;
$post_id = $post->ID;

wp_enqueue_style('acf7db_schedule_report_css');
wp_enqueue_style('vsz_acf7db_datatables_min_css');
wp_enqueue_script('vsz_acf7db_datatables_min_js');

$schedule_type = get_post_meta($post_id,"schedule_type",true);

if(empty($post_id) || empty($schedule_type)){
	?><script>
		jQuery(document).ready(function(){
			jQuery("#vsz_acf7db_schedule_report_history").hide();
		});
	</script><?php
}

// Valid extensions
$valid_file_extension = array('csv','xls','xlsx');

// Valid schedule type
$valid_schedule_type = array('daily','weekly' ,'monthly','yearly');

// Get real path for our folder
$upload_dir = wp_upload_dir();
// $rootPath = plugin_dir_path(dirname(__FILE__))."export/csv";
$rootPath = $upload_dir['basedir'] . '/ScheduleReport';

if (!file_exists($rootPath)) {
    wp_mkdir_p($rootPath, 0777, true);
	
}

$rootPathQuickView = $upload_dir['basedir'] . '/ScheduleReport/QuickView';
if (!file_exists($rootPathQuickView)) {
	wp_mkdir_p($rootPathQuickView, 0777, true);
}

// Create recursive directory iterator
/** @var SplFileInfo[] $files */
$files = new RecursiveIteratorIterator(
	new RecursiveDirectoryIterator($rootPath),
	RecursiveIteratorIterator::LEAVES_ONLY
);


?><input type="button" name="acf7_db_reports_delete_multiple"class="reports_delete_multiple btn-danger" value="Delete Multiple" />
<table id="acf7db_sr_report_table" class="form-table widefat fixed striped" border="1">
	<thead>
		<tr>
			<td width="5%" class="checkbox-typ-column noSort"><input type="checkbox" class="headTypeCheck" autocomplete="off" /></td>
			<td width="15%"><?php _e('Date',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></td>
			<td width="60%"><?php _e('File Name',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></td>
			<td width="20%" class="noSort"><?php _e('Action',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></td>
		</tr>
	</thead>
	<tbody><?php
		$recordFlag = false;
		
		if(!empty($files)){
			
			foreach ($files as $name => $file){
				
				// Get real and relative path for current file
				$filePath = $file->getRealPath();
				$create_time = filectime($filePath);
				
				$fileNameArr = explode($rootPath,$filePath);
				
				if(!isset($fileNameArr[1]) || empty($fileNameArr[1])){
					continue;
				}
				
				$fileName = ltrim($fileNameArr[1],"/");
				$file_time = "";
				
				// Extract time stamp from file name
				$name_arr = explode('-',$fileName);
				$count_arr = count($name_arr);
				if($count_arr<6 || $name_arr[2] != $post_id){
					continue;
				}
				
				// Example of generating new file:- $newFileName = 'schedule-report-'.get_the_title($post_id).'-'.$schedule_type.'-'.$timeStamp.'.csv';
				// -1 is used as time stamp is last
				$timeStampStr = isset($name_arr[$count_arr-1]) ? $name_arr[$count_arr-1] : "";
				if(empty($timeStampStr)){
					continue;
				}
				
				$dateTimeArr = explode(".",$timeStampStr);
				if(count($dateTimeArr) == 2){
					if(!in_array($dateTimeArr[1],$valid_file_extension)){
						continue;
					}
					else{
						$file_time = DateTime::createFromFormat('Ymdhis', $dateTimeArr[0]);
					}
				}
				else{
					continue;
				}
				
				if(!empty($file_time)){
					$file_time_display = $file_time->format('d-m-Y');
					$time = $file_time->format('U');
				}
				else{
					// This is file create time
					$file_time_display = date('d-m-Y',$create_time);
					$time = $create_time;
				}
				
				// Create new array with all data
				$data[] = array(
							'fileName' => $fileName,
							'time' => $time,
							'file_time_display' => $file_time_display,
							'filepath' => $filePath
						);
				
			}
			
			if(!empty($data)){
				usort($data, function($a, $b){ // sort by time latest
					if(isset($b['time']) && isset($a['time'])){
						return $b['time'] - $a['time'];
					}
					else{
						return false;
					}
				});
			}
			
			if(!empty($data)){
				foreach($data as $file){
					$filePath = $file["filepath"];
					$create_time = $file["time"];
					$time_display = $file["file_time_display"];
					$fileName = $file["fileName"];
					
					$file_url = $upload_dir['baseurl'] . '/ScheduleReport/'.$fileName;
					
					
					$recordFlag = true;
					?><tr>
						<td class="checkbox-typ-column">
							<input type="checkbox" class="singleTypeCheck" data-path="<?php echo $filePath; ?>" autocomplete="off" />
						</td>
						<td><?php
							// This is time generated from file name timestamp
							echo $time_display;					
						?></td>
						<td><?php
							echo $fileName;
						?></td>
						<td>
							<a href="<?php echo $file_url; ?>"><?php _e('Download',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></a> | <a class="acf7db_sr_delete_url"  href="#" data-path="<?php echo $filePath; ?>"><?php _e('Delete',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></a>
						</td>
					</tr><?php
				}
			}
		}
	?></tbody>
</table>
<div class="no-records-text"><?php _e('No reports found!',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></div>
<script>
jQuery(document).ready(function($){
	
	var oTable;
	
	jQuery(window).load(function(){
		oTable = jQuery('#acf7db_sr_report_table').DataTable({
			"paging":   true,
			"ordering": true,
			"info":	false,
			"lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]],
			"order": [[ 2, "desc" ]],
			"columnDefs" : [{ targets: "noSort", orderable: false }]
		});
		
	});
<?php
	if($recordFlag === false){
?>
		jQuery("#acf7db_sr_report_table").hide();
		jQuery("#acf7db_sr_report_table").attr("data-hide","yes");
		jQuery(".reports_delete_multiple").hide();
		jQuery(".no-records-text").show();<?php
	}
	else{
?>
		jQuery(".no-records-text").hide();
		<?php
	}
?>

	var post_id = jQuery(this).attr("data-id");
		
	if(jQuery(".wrap .schedule_report_error").length < 1){
		jQuery(".wp-header-end").after('<div class="schedule_report_error"></div>');
	}
	if(jQuery(".wrap .schedule_report_error").length < 1){
		 jQuery(".page-title-action").parent().after('<div class="schedule_report_error"></div>');
	}
	
	// When selecting single file
	jQuery("#acf7db_sr_report_table").on("change",".singleTypeCheck",function(){
		var numTotal = jQuery(".singleTypeCheck").length;
		var numSelected = jQuery(".singleTypeCheck:checked").length;
		
		if(numSelected == numTotal){
			jQuery(".headTypeCheck").attr("checked",true);
		}
		else{
			jQuery(".headTypeCheck").attr("checked",false);
		}
	});
	
	// When selecting "Select All"
	jQuery("#acf7db_sr_report_table").on("change",".headTypeCheck",function(){
		var rows = oTable.rows({ 'search': 'applied' }).nodes();
		jQuery('input[type="checkbox"]', rows).prop('checked', this.checked);
	});
	
	// Delete Multiple Functionality
	jQuery(".reports_delete_multiple").click(function(){
		var rows = oTable.rows({ 'search': 'applied' }).nodes();
		var checkedNum = jQuery('input[type="checkbox"]:checked', rows).length;
		if(checkedNum>0){
			if(confirm("<?php _e('Are you sure to delete selected record(s)?',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>")){
				delete_multiple_reports();
			}
			else{
				return false;
			}
		}
		else{
			alert("<?php _e('Please select atleast one report to delete.',VSZ_ACF7DB_SR_TEXT_DOMAIN); ?>");
			return false;
		}
	});
	
	function delete_multiple_reports(){
		var files = [];
		jQuery('#acf7db_sr_report_table tbody input[type="checkbox"]:checked').each(function(){
			var thisVal = jQuery(this).attr("data-path");
			files.push(thisVal);
		});
		
		var file_path_str = files.toString();
		
		jQuery.ajax({
			url: '<?php echo admin_url('admin-ajax.php');?>',
			data: {
				'action' : "acf7db_sr_delete_file_report",
				'filePath':file_path_str
			},
			type: 'POST',
			success: function(data) {
				if(data == "y"){
					jQuery(".schedule_report_error").html('<div id="message" class="updated notice notice-success is-dismissible">'
															+'<p><?php _e("File(s) deleted successfully.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
															+'<button type="button" class="notice-dismiss">'
																+'<span class="screen-reader-text">Dismiss this notice.</span>'
															+'</button>'
														+'</div>');
				}
				else{
					jQuery(".schedule_report_error").html('<div id="message" class="notice error is-dismissible">'
															+'<p><?php _e("Sorry file(s) was not deleted.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
															+'<button type="button" class="notice-dismiss">'
																+'<span class="screen-reader-text">Dismiss this notice.</span>'
															+'</button>'
														+'</div>');
				}
				
				jQuery("html,body").animate({ scrollTop: jQuery(".schedule_report_error").offset().top-100 }, 1000);
				setTimeout(function() {
					location.reload();
				}, 2000);
			}
		});
	}
	
	jQuery(".acf7db_sr_delete_url").click(function(){
		var filePath = jQuery(this).attr("data-path");
		jQuery.ajax({
			url: '<?php echo admin_url('admin-ajax.php');?>',
			data: {
				'action' : "acf7db_sr_delete_file_report",
				'filePath':filePath
			},
			type: 'POST',
			success: function(data) {
				if(data == "y"){
					jQuery(".schedule_report_error").html('<div id="message" class="updated notice notice-success is-dismissible">'
															+'<p><?php _e("File deleted successfully.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
															+'<button type="button" class="notice-dismiss">'
																+'<span class="screen-reader-text">Dismiss this notice.</span>'
															+'</button>'
														+'</div>');
				}
				else{
					jQuery(".schedule_report_error").html('<div id="message" class="notice error is-dismissible">'
															+'<p><?php _e("Sorry file was not deleted.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
															+'<button type="button" class="notice-dismiss">'
																+'<span class="screen-reader-text">Dismiss this notice.</span>'
															+'</button>'
														+'</div>');
				}
				
				jQuery("html,body").animate({ scrollTop: jQuery(".schedule_report_error").offset().top-100 }, 1000);
				setTimeout(function() {
					location.reload();
				}, 2000);
			}
		});
		
		return false;
	});
	
	// Run now functionality
	jQuery("#schedule_run_now").click(function(){
		var post_id = jQuery("#post_ID").val();
		
		jQuery.ajax({
			url: '<?php echo admin_url('admin-ajax.php');?>',
			data: {
				'action' : "acf7db_sr_run_now",
				'post_id':post_id
			},
			type: 'POST',
			success: function(data) {
				if(data == "y"){
					jQuery(".schedule_report_error").html('<div id="message" class="updated notice notice-success is-dismissible">'
															+'<p><?php _e("Report generated successfully.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
															+'<button type="button" class="notice-dismiss">'
																+'<span class="screen-reader-text">Dismiss this notice.</span>'
															+'</button>'
														+'</div>');
				}
				else{
					jQuery(".schedule_report_error").html('<div id="message" class="notice error is-dismissible">'
															+'<p><?php _e("Sorry report was not generated.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
															+'<button type="button" class="notice-dismiss">'
																+'<span class="screen-reader-text">Dismiss this notice.</span>'
															+'</button>'
														+'</div>');
				}
				
				jQuery("html,body").animate({ scrollTop: jQuery(".schedule_report_error").offset().top-100 }, 1000);
				setTimeout(function() {
					location.reload();
				}, 2000);
			}
		});
		
		return false;
	});
	
	// Quick View functionality
	jQuery("#schedule_rule_quick_view").click(function(){
		var post_id = jQuery("#post_ID").val();
		
		jQuery('.vsz-error').remove();
		jQuery('.schedule_report_error').html('');
		var checkForm = true;
		
		var schedule_file_type = jQuery("#schedule_file_type").val();
		var schedule_type = jQuery("#schedule_type").val();
		if(schedule_type != ''){
			
			//Check schedule repeat field empty or not
			if(jQuery("#schedule_repeat").val() == '' ){
				jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p><?php _e("Enter Repeat Every",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
				jQuery("#schedule_repeat").css("border","1px solid red");
				checkForm = false;
			}
			else if(parseInt(jQuery("#schedule_repeat").val()) == 0 ){
				jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p><?php _e("Repeat Every value should not be 0.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
				jQuery("#schedule_repeat").css("border","1px solid red");
				checkForm = false;
			}
			else{
				jQuery("#schedule_repeat").css("border","");
			}
			
			//Check schedule form field empty or not
		}
		
		// Form ID
		if(jQuery("#schedule_form_id").val() == '' ){
			jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p><?php _e("Select Schedule For form.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
			jQuery("#schedule_form_id").css("border","1px solid red");
			checkForm = false;
		}
		else{
			jQuery("#schedule_form_id").css("border","");
		}
		
		var check_rule = jQuery('.rule_data .rule-main').length;
		if(check_rule != 0){
			var chech_rule_error = 0;
			jQuery('.rule_data .rule-main').each(function(){
				var fields_value =  jQuery(this).find('.fields_value').val();
				if(fields_value == ''){
					chech_rule_error = 1;
					jQuery(this).find('.fields_value').css("border","1px solid red");
					checkForm = false;
				}else{
					jQuery(this).find('.fields_value').css("border","");
				}
			});
			if(chech_rule_error == 1){
				jQuery('.schedule_report_error').append('<div id="message" class="notice error is-dismissible"><p><?php _e("Enter rule value.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');	
			}
		}
		
		if(checkForm){
			var originalAction = jQuery("#originalaction").val();
			var hiddenaction = jQuery("#hiddenaction").val();
			
			jQuery("#originalaction").val("acf7db_sr_quick_view");
			jQuery("#hiddenaction").val("acf7db_sr_quick_view");
			
			var fd = jQuery("#post").serialize();
			
			jQuery("#originalaction").val(originalAction);
			jQuery("#hiddenaction").val(hiddenaction);
			
			jQuery.ajax({
				url: '<?php echo admin_url('admin-ajax.php');?>',
				data: fd,
				type: 'POST',
				success: function(data) {
					var dataArr = data.split("@@~~@@");
					if(dataArr[0] == "y"){
						jQuery(".schedule_report_error").html('<div id="message" class="updated notice notice-success is-dismissible">'
																+'<p><?php _e("Report generated successfully.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?><a href="'+dataArr[1]+'">Download</a></p>'
																+'<button type="button" class="notice-dismiss">'
																	+'<span class="screen-reader-text">Dismiss this notice.</span>'
																+'</button>'
															+'</div>');
					}
					else if(dataArr[0] == "n"){
						jQuery(".schedule_report_error").html('<div id="message" class="updated notice notice-success is-dismissible">'
																+'<p><?php _e("No records found for given rules.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
																+'<button type="button" class="notice-dismiss">'
																	+'<span class="screen-reader-text">Dismiss this notice.</span>'
																+'</button>'
															+'</div>');
					}
					else{
						jQuery(".schedule_report_error").html('<div id="message" class="notice error is-dismissible">'
																+'<p><?php _e("Sorry report was not generated.",VSZ_ACF7DB_SR_TEXT_DOMAIN); ?></p>'
																+'<button type="button" class="notice-dismiss">'
																	+'<span class="screen-reader-text">Dismiss this notice.</span>'
																+'</button>'
															+'</div>');
					}
					
					jQuery("html,body").animate({ scrollTop: jQuery(".schedule_report_error").offset().top-100 }, 1000);
				}
			});
			return false
		}
		else{
			jQuery("html,body").animate({ scrollTop: jQuery(".schedule_report_error").offset().top-100 }, 1000);
		}
	});
});
</script>