<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ){
	die('Un-authorized access!');
}
// Necessary condition to prevent direct access
if(!is_user_logged_in() || empty($_POST)){
	return;
}
//Check current user capabilities
if(!current_user_can( 'manage_options' )) return;

//Check nonce fields is set or not
if(!isset($_POST['vsz_acf7db_schedule_nonce']) || empty($_POST['vsz_acf7db_schedule_nonce'])){
	return;
}
//set website time zone from here 
vsz_schedule_report_get_site_time_zone();
//checking nonce is valid or not
$nonce = $_POST['vsz_acf7db_schedule_nonce'];
//var_dump($post);exit;
if(!wp_verify_nonce( $nonce, 'vsz-acf7db-schedule-nonce-'.$post_id ) ) {
	// This nonce is not valid.
	return;
}
$postArray = array( 'ID'=> $post_id, 'post_status' => 'draft' );
//Get all fields information here
$schedule_type = isset($_POST['schedule_type']) ? sanitize_text_field($_POST['schedule_type']) : '';
$schedule_file_type = isset($_POST['schedule_file_type']) ? sanitize_text_field($_POST['schedule_file_type']) : '';
$schedule_repeat = isset($_POST['schedule_repeat']) ? absint($_POST['schedule_repeat']) : '';
$schedule_week_day = isset($_POST['schedule_week_day']) ? sanitize_text_field($_POST['schedule_week_day']) : '';
$schedule_time = isset($_POST['schedule_time']) ? sanitize_text_field($_POST['schedule_time']) : '';
$schedule_end_date = isset($_POST['schedule_end_date']) ? sanitize_text_field($_POST['schedule_end_date']) : '';
$schedule_form_id = isset($_POST['schedule_form_id']) ? absint($_POST['schedule_form_id']) : '';
$schedule_contact_form_field = isset($_POST['schedule_contact_form_field']) ? $_POST['schedule_contact_form_field'] : '';
$schedule_contact_form_rule = isset($_POST['schedule_contact_form_rule']) ? $_POST['schedule_contact_form_rule'] : '';
//var_dump($schedule_contact_form_rule);exit;
$schedule_option = isset($_POST['vsz_acf7db_schedule_option']) ? sanitize_text_field($_POST['vsz_acf7db_schedule_option']) : '';

// Email fields
$schedule_email_active = isset($_POST['schedule_email_active']) ? sanitize_text_field($_POST['schedule_email_active']) : '';
$schedule_from_name = isset($_POST['schedule_from_name']) ? sanitize_text_field($_POST['schedule_from_name']) : '';
if(isset($_POST['schedule_from_email']) && $_POST['schedule_from_email'] == '[ADMIN_EMAIL]'){
	$schedule_from_email = $_POST['schedule_from_email'];
}else{
	$schedule_from_email = isset($_POST['schedule_from_email']) ? sanitize_email($_POST['schedule_from_email']) : '';
}

$schedule_to = isset($_POST['schedule_to']) ? sanitize_text_field($_POST['schedule_to']) : '';
$schedule_subject = isset($_POST['schedule_subject']) ? sanitize_text_field($_POST['schedule_subject']) : '';
$schedule_contentType = isset($_POST['schedule_contentType']) ? sanitize_text_field($_POST['schedule_contentType']) : 'no';
$schedule_message_body = isset($_POST['schedule_message_body']) ? $_POST['schedule_message_body'] : '';

// Email fields validation
if($schedule_to != '[ADMIN_EMAIL]'){
	$schedule_to_validation = explode(',',$schedule_to);
	$schedule_to_validation_email = array_map( 'sanitize_email', $schedule_to_validation);
	if(isset($schedule_to_validation_email) && !empty($schedule_to_validation_email) && array_filter($schedule_to_validation_email)){
		$schedule_to = implode(',',$schedule_to_validation_email);
	}else{
		$schedule_to = '';
	}
}
$errormessage = '';

if(!empty($schedule_type)){

	//Check all required fields fill or not
	if(empty($schedule_repeat)){
		$errormessage[] = __("Please enter schedule repeat.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($schedule_time)){
		$errormessage[] = __("Please enter schedule time.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
}
//Checking if the option is delete or export and enter id option is export
if($schedule_option != "delete"){
	if(empty($schedule_form_id)){
		$errormessage[] = __("Either no forms submitted or you just forgot to select one form to export the records.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($schedule_from_name)){
		$errormessage[] = __("Please enter from name.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($schedule_from_email)){
		$errormessage[] = __("Please enter from email.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($schedule_to)){
		$errormessage[] = __("Please enter to email.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($schedule_subject)){
		$errormessage[] = __("Please enter email subject.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($schedule_message_body)){
		$errormessage[] = __("Please enter email message body.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
}

//Delete options started
$delete_day = isset($_POST['delete_day']) ? sanitize_text_field($_POST['delete_day']) : '';
$delete_day_number = isset($_POST['delete_day_number']) ? sanitize_text_field($_POST['delete_day_number']) : '';
$schedule_delete_form_id = isset($_POST['schedule_delete_form_id']) ? $_POST['schedule_delete_form_id'] : '';

if($schedule_option == "delete"){
	if(empty($delete_day)){
		$errormessage[] = __("Please select day type for deleting the records.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($delete_day_number)){
		$errormessage[] = __("Please enter number of days before to be set for deleting the records.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
	if(empty($schedule_delete_form_id)){
		$errormessage[] = __("Either no forms submitted or you just forgot to select one form to delete the records.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
	}
}


if(!empty($errormessage)){
	$notice = get_option('otp_notice');
	$notice[$post_id] = $errormessage;
	update_option('otp_notice',$notice);
	wp_update_post( $postArray, false );
	return __("Kindly fill the fields correctly.",VSZ_ACF7DB_SR_TEXT_DOMAIN);
}

//Check schedule type value empty or not if not empty then added schedule
if(!empty($schedule_type)){

	//check end date validation
	$s_end_date = '';
	if(!empty($schedule_end_date)){
		$s_end_date = date_create_from_format("d/m/Y",$schedule_end_date);
		if(!empty($s_end_date)){
			//Get end date information
			$s_end_date =  date_format($s_end_date,"Y-m-d");
		}
	}

	//check from date validation
	$s_from_date = '';
	if(!empty($schedule_from_date)){
		$s_from_date = date_create_from_format("d/m/Y",$schedule_from_date);
		if(!empty($s_from_date)){
			//Get from date information
			$s_from_date =  date_format($s_from_date,"Y-m-d");
		}
	}

	//check from date validation
	$s_to_date = '';
	if(!empty($schedule_to_date)){
		$s_to_date = date_create_from_format("d/m/Y",$schedule_to_date);
		if(!empty($s_to_date)){
			//Get to date information
			$s_to_date =  date_format($s_to_date,"Y-m-d");
		}
	}




	//Save all fields information here
	update_post_meta($post_id,'schedule_type',$schedule_type);
	update_post_meta($post_id,'schedule_repeat',$schedule_repeat);
	update_post_meta($post_id,'schedule_time',$schedule_time);
	update_post_meta($post_id,'schedule_end_date',$s_end_date);
	update_post_meta($post_id,'schedule_file_type',$schedule_file_type);
	update_post_meta($post_id,'schedule_option',$schedule_option);

	//Save week day and month date information
	if($schedule_type == 'weekly'){
		update_post_meta($post_id,'schedule_week_day',$schedule_week_day);
	}
	else if($schedule_type == 'monthly'){
		update_post_meta($post_id,'schedule_week_day','');
	}
	else{
		update_post_meta($post_id,'schedule_week_day','');
	}

}
else{
	//Save all fields information here
	update_post_meta($post_id,'schedule_type','');
	update_post_meta($post_id,'schedule_repeat','');
	update_post_meta($post_id,'schedule_time','');
	update_post_meta($post_id,'schedule_end_date','');
	update_post_meta($post_id,'schedule_week_day','');
	update_post_meta($post_id,'schedule_file_type','');
	update_post_meta($post_id,'schedule_option','');
}

if($schedule_option != "delete"){
	//Email field
	update_post_meta($post_id,'schedule_email_active',$schedule_email_active);
	update_post_meta($post_id,'schedule_from_name',$schedule_from_name);
	update_post_meta($post_id,'schedule_from_email',$schedule_from_email);
	update_post_meta($post_id,'schedule_to',$schedule_to);
	update_post_meta($post_id,'schedule_subject',$schedule_subject);
	update_post_meta($post_id,'schedule_contentType',$schedule_contentType);
	update_post_meta($post_id,'schedule_message_body',$schedule_message_body);

	//contact form field
	update_post_meta($post_id,'schedule_form_id',$schedule_form_id);
	update_post_meta($post_id,'schedule_contact_form_field',$schedule_contact_form_field);
	update_post_meta($post_id,'schedule_contact_form_rule',$schedule_contact_form_rule);
}else{
//Email field
	update_post_meta($post_id,'schedule_email_active','');
	update_post_meta($post_id,'schedule_from_name','');
	update_post_meta($post_id,'schedule_from_email','');
	update_post_meta($post_id,'schedule_to','');
	update_post_meta($post_id,'schedule_subject','');
	update_post_meta($post_id,'schedule_contentType','');
	update_post_meta($post_id,'schedule_message_body','');

	//contact form field
	update_post_meta($post_id,'schedule_form_id','');
	update_post_meta($post_id,'schedule_contact_form_field','');
	update_post_meta($post_id,'schedule_contact_form_rule','');
}
//Delete records
if($schedule_option == "delete"){
	//Delete fields

	if(!empty($schedule_delete_form_id )){
		$schedule_delete_form_ids = implode(',', $schedule_delete_form_id);
	}else{
		$schedule_delete_form_ids = '';
	}

	update_post_meta($post_id,'delete_day',$delete_day);
	update_post_meta($post_id,'delete_day_number',$delete_day_number);
	update_post_meta($post_id,'schedule_delete_form_id',$schedule_delete_form_ids);

}else{
	//Delete fields
	update_post_meta($post_id,'delete_day','');
	update_post_meta($post_id,'delete_day_number','');
	update_post_meta($post_id,'schedule_delete_form_id','');
}

///Add Schedule
if(!empty($schedule_type)){

	if($schedule_type == 'daily'){
		$interval = $schedule_repeat * 86400;
	}
	if($schedule_type == 'weekly'){
		$interval = $schedule_repeat * 604800;
	}
	if($schedule_type == 'monthly'){
		$interval = $schedule_repeat * 2592000;
	}
	if($schedule_type == 'yearly'){
		$interval = $schedule_repeat * 31536000;
	}
	$old_scheds = get_option( 'vsz_cron_schedules', array() );

	$date = strtotime(date('Y-m-d'.$schedule_time)) + $interval;

	if($schedule_type == 'weekly'){
		$arr_days = array(1 => "monday", 2 => "tuesday", 3 => "wednesday", 4 => "thursday", 5 => "friday", 6 => "saturday", 7 => "sunday");
		$next_day = strtotime('next '.$arr_days[$schedule_week_day]);
		$next_day_date = date('Y-m-d',$next_day);
		$date = strtotime(date($next_day_date.$schedule_time)) + $interval;
	}
	$old_scheds[ 'vsz_'.$post_id ] = array(
		'interval' => $interval,
		'display'  => get_the_title($post_id),
	);
	update_option( 'vsz_cron_schedules', $old_scheds );
	wp_clear_scheduled_hook( 'vsz_cron_schedules_hooks', array("id"=>$post_id) );
	wp_schedule_event($date, 'vsz_'.$post_id, 'vsz_cron_schedules_hooks',array("id"=>$post_id) );
	//update next schedule date
	update_post_meta($post_id,'next_schedule',$date);
}
else{
	//remove all crones from here
	wp_clear_scheduled_hook( 'vsz_cron_schedules_hooks', array("id"=>$post_id) );
}

