<?php

/**
 * Fired during plugin activation
 *
 * @link       https://www.vsourz.com
 * @since      1.0.0
 *
 * @package    Acf7db_schedule_report
 * @subpackage Acf7db_schedule_report/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Acf7db_schedule_report
 * @subpackage Acf7db_schedule_report/includes
 * @author     vsourz Digital <support@vsourz.com>
 */
class Acf7db_schedule_report_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {
		delete_quickview_files();
	}
	
	
}

// Add crone schedule for deleting quick view files
function delete_quickview_files(){
	$time = time();
	if(!wp_next_scheduled('vsz_quickview_delete_callback')){
		wp_schedule_event($time, 'vsz_quickview_delete', 'vsz_quickview_delete_callback');	
	}
}