<?php

/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       https://www.vsourz.com
 * @since      1.0.0
 *
 * @package    Acf7db_schedule_report
 * @subpackage Acf7db_schedule_report/includes
 */

/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @since      1.0.0
 * @package    Acf7db_schedule_report
 * @subpackage Acf7db_schedule_report/includes
 * @author     vsourz Digital <support@vsourz.com>
 */
class Acf7db_schedule_report_i18n {


	/**
	 * Load the plugin text domain for translation.
	 *
	 * @since    1.0.0
	 */
	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'acf7db-schedule-report',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

	}



}
